100 :::::
110 :
120 REMark Orbiter3Dv2_bas. QL Perspective Animation. by S.Poole. v29dec2021
130 CLEAR: MODE 8: RESTORE : REMark written on QPC2
140 WINDOW 512,256,0,0: CLS: WINDOW#2,512,206,0,0: REMark window 512-128,256,64,0
150 DIM i$(16): pc=1
160 RANDOMISE:  i$=' ': sz=16: xt=64: IF pc=0: xt=32
170 easy=1: IF pc=1: easy=0
180  IF pc='1': asp=.76: ELSE asp=1
190 PAPER 0: INK 7: CLS: CSIZE 0,0: ss=1: SCALE ss,ss/-2/asp,ss/-2 : CSIZE 0,0
200 :
210 :::::::::: REMark initialise variables :
220  REMark qz=0: REMark slp=0: qz=rs*TAN(RAD(slp)): REMark for future use.!
230 r90=RAD(90): r180=RAD(180): r270=RAD(270): r360=RAD(360)
240 Xaxis=1: Yaxis=2: Zaxis=3: x=1: y=2: z=3: DN=xt*18+18
250 DIM cb(9,3),th(5,3),gr(17,3),bs(9,3),tr(xt,3),Cw(DN,3),aw(DN,3),t(DN,2)
260 DIM ba(DN,3),gd(DN,3),V(xt,6): start=0
270 zm=4: inf=1E-8: inf=0: ff=0: CBng=0: ct=0: ctcb=0: ctth=0: j=0
280 Rng=0: qqx=0: qqy=0: qqz=0: Rx=0: Ry=0: Rz=0: cx=0: cy=0: cz=0: ax=0: ata=0
290 ay=0: az=0: rs=0: nng=0: tx=0: ty=0: tzz=0: Fx=0: fy=0: fz=0: fh=0: c=0: b=0
300 Rox=0: Roy=0: Roz=0: m=0: n=0: loop=0: kt=0: ktc=0: kth=0: lx=0: ly=0: lz=0
310 lh=0: e=0: h=0: so=0: sa=0: oa=0: ang=0: ng=0: op=0: aj=0: hp=0: Sop=0: Saj=0
320 d1=0: loop3=0: zapx=0: zapy=0: zapz=0: tn=0: tm=0: diam=0: iz=0: pz=0: in=0
330 hitz=0: hity=0: im=0: hitx=0: ok=0: omm=0: onn=0: ky2=0: px=0: p=0: py=0: pz=0
340 ky1=0: drn=0: qi=0: ctr=0: ct2=0: ctth2=0: ctcb2=0: ars=0: min=0: rs2=0
350 :
360 ::::::::::::
370 CSIZE 3,1: AT 2,2: PRINT ' 3D QLander setup...': CSIZE 0,0
380 AT 8,1 : PRINT 'Line 150... LET PC=0 for emulators... or 1 for QL systems'
390 AT 11,1: PRINT 'Tested on QPC2(fast) & SGC under QDOS(!) or SMSQ/E(slow)'
400 AT 14,1: PRINT "Easier to play on QL systems: (Less 'precise' for speed!)"
410 AT 17,1: PRINT '8 colours, so Not for monochrome monitors..'
420 AT 20,1: PRINT 'HIT any key...or (ESCape to quit).': PAUSE
430 :
440 :                                 zm=RND(1 TO 4) : of=RND(0 TO 12)
450 FOR f=1 TO 9: READ ff: cb(f,x)=ff*zm+of +16
460 FOR f=1 TO 9: READ ff: cb(f,y)=ff*zm+of +16: REMark cube
470 FOR f=1 TO 9: READ ff: cb(f,z)=ff*zm
480 :                                 zmt=RND(1 TO 3): of=RND(0 TO 16)
490 FOR f=1 TO 5: READ ff: th(f,x)=ff*zmt+of
500 FOR f=1 TO 5: READ ff: th(f,y)=ff*zmt+of: REMark tetrahedra
510 FOR f=1 TO 5: READ ff: th(f,z)=ff*zmt
520 :                                   zm=RND(1 TO 3): of=RND(16 TO 40)
530 FOR f=1 TO 17: READ xx: gr(f,x)=-xx*zm*2 +of: REMark stretch along 'x' axis
540 FOR f=1 TO 17: READ yy: gr(f,y)=-yy*zm   -of: REMark iceberg
550 FOR f=1 TO 17: READ zz: gr(f,z)=zz-12
560 iz=gr(f,z)
570 :                                 zm=7
580 FOR f=1 TO 8: READ xx: bs(f,x)=xx*zm
590 FOR f=1 TO 8: READ yy: bs(f,y)=yy*zm
600 FOR f=1 TO 8: READ zz: bs(f,z)=zz*zm -15: REMark 'ground' base
610 :::::::::
620 :
630 REMark calculate ALL cartesian x,y,z coordinates :
640 :
650 CBng=RAD(0): ct=0: ctcb=0: ctth=0: ctbs=0: REMark object-array index counts.
660 FOR f=0 TO xt STEP 1
670  :
680  REMark set ALL eye-points ok
690  tr(f,x)=3*f+.1: tr(f,y)=2*-f-.1: tr(f,z)=0: REMark eye-point trajectory
700  INK 7:  AT 1,1: PRINT xt-f!!
710 :
720 FOR j=1 TO 17
730 ct=ct+1: gd(ct,x)=gr(j,x): gd(ct,y)=gr(j,y): gd(ct,z)=gr(j,z)
740 END FOR j:   REMark iceberg ok
750 :
760 CBng=CBng+RAD(6)
770  IF CBng>=r360: CBng=CBng-r360
780 FOR j=1 TO 8
790  ctcb=ctcb+1: Rng=CBng
800     qqx=cb(j,x): qqy=cb(j,y): qqz=cb(j,z)+inf
810        rotate1 3,Rng,qqx,qqy,qqz
820        rotate1 2,Rng,Rx,Ry,Rz
830        rotate1 1,Rng,Rx,Ry,Rz
840         aw(ctcb,x)=Rx: aw(ctcb,y)=Ry: aw(ctcb,z)=Rz
850 END FOR j:  REMark tumble cube CW ok
860 :
870 FOR j=1 TO 8
880  ctcb=ctcb+1: Rng=CBng
890     qqx=cb(j,x): qqy=cb(j,y): qqz=cb(j,z)+inf
900        rotate2 1,Rng,qqx,qqy,qqz
910        rotate2 3,Rng,Rx,Ry,Rz
920        rotate2 2,Rng,Rx,Ry,Rz
930         aw(ctcb,x)=Rx: aw(ctcb,y)=Ry: aw(ctcb,z)=Rz
940 END FOR j:   REMark tumble cube ACW ok
950 :
960 :
970 FOR j=1 TO 5
980  ctth=ctth+1: Rng=CBng
990     qqx=th(j,x)+8: qqy=th(j,y)+8: qqz=th(j,z)+inf
1000        rotate1 3,Rng,qqx,qqy,qqz
1010        rotate1 2,Rng,Rx,Ry,Rz
1020        rotate1 1,Rng,Rx,Ry,Rz
1030 Cw(ctth,x)=Rx: Cw(ctth,y)=Ry: Cw(ctth,z)=Rz
1040 END FOR j:   REMark articulte tetrahedron CW ok
1050 :
1060 FOR j=1 TO 5
1070  ctth=ctth+1: Rng=CBng
1080     qqx=th(j,x)-8: qqy=th(j,y)-8: qqz=th(j,z)+inf
1090        rotate2 2,Rng,qqx,qqy,qqz
1100        rotate2 1,Rng,Rx,Ry,Rz
1110        rotate2 3,Rng,Rx,Ry,Rz
1120 Cw(ctth,x)=Rx: Cw(ctth,y)=Ry: Cw(ctth,z)=Rz
1130 END FOR j:  REMark articulate tetrahedron ACW ok
1140 :
1150 : ctx=0: cty=0
1160 FOR j=1 TO 8
1170 ctbs=ctbs+1
1180     qqx=bs(j,x): qqy=bs(j,y): qqz=bs(j,z)
1190     ctx=ctx+qqx: cty=cty+qqy
1200 ba(ctbs,x)=qqx: ba(ctbs,y)=qqy: ba(ctbs,z)=qqz
1210 END FOR j:   REMark swing 'ground' base 'x & y' directions ok
1220 :
1230 REMark ground barycentre :
1240  ctbs=ctbs+1:  ba(ctbs,x)=ctx/8: ba(ctbs,y)=cty/8: ba(ctbs,z)=qqz
1250 :
1260 END FOR f: CLS
1270 :
1280 :::::::::::::::::::::
1290 :
1300 REMark calculate ALL the coordinates in screen perspective:
1310 :
1320  ct=0: ctcb=0: ctth=0: ctbs=0: pp=20: dia=0
1330 px=RND(-pp TO pp): py=RND(-pp TO pp): pz=RND(-pp TO pp): REMark 'pod' xyz
1340 FOR f=0 TO xt STEP 1
1350 :
1360 REMark prepare parameters for each window frame:
1370 INK 7: AT 1,1: PRINT 'Preparing...'!xt-f!!
1380 cx=32: cy=-32: cz=0: REMark fixed 'space referential' datum
1390 ax=xt-tr(f,x)+1: ay=tr(f,y): az=tr(f,z): REMark the moving 'eye' points.
1400 rs=SQRT(ay*ay+ax*ax)  : nng=ATN_(ay,ax): REMark radius & azimut 'eye & target'.
1410 tx=2*rs*SIN(nng)+ax: ty=2*rs*COS(nng)+ay: tzz=cz: REMark flat 'target' point.
1420 :
1430         REMark qz=rs*TAN(RAD(slp)): REMark for future 'dip' use !
1440    Fx=ax-tx: fy=ay-ty: fz=tzz : fh=((Fx^2)+(fy^2))^.5 : min=ty: ars=ABS(rs)
1450  c=ATN_(fy,Fx): b=ATN_(fz,fh): REMark focalise to frame point.... OK
1460  V(f,1)=b: V(f,2)=c: V(f,3)=tx: V(f,4)=ty: V(f,5)=tzz: V(f,6)=ax
1470 :
1480 FOR j=1 TO 17
1490 ct=ct+1: IF rs2>ay THEN
1500 Rox=gd(ct,x): Roy=gd(ct,y): Roz=gd(ct,z)
1510  ok=VIEW_(Rox,Roy,Roz): t(ct,1)=m: t(ct,2)=n
1520 END IF : END FOR j: REMark iceberg 'tip' points ok
1530 INK 5: drawGRid3d ct-17: crosswires ct
1540 :
1550 FOR j=1 TO 8
1560 ctcb=ctcb+1: IF rs2>ay THEN
1570          Rox=aw(ctcb,x)+ax: Roy=aw(ctcb,y)+ay: Roz=aw(ctcb,z)+az/2
1580 ok=VIEW_(Rox,Roy,Roz): aw(ctcb,1)=m: aw(ctcb,2)=n
1590 END IF : END FOR j:  REMark 1st cube ok
1600 INK 2: drawCB3d ctcb-8
1610 :
1620 FOR j=1 TO 8
1630  ctcb=ctcb+1: IF rs2>ay THEN
1640          Rox=aw(ctcb,x)+ax: Roy=aw(ctcb,y)+ay: Roz=aw(ctcb,z)+az
1650 ok=VIEW_(Rox,Roy,Roz): aw(ctcb,1)=m: aw(ctcb,2)=n
1660 END IF : END FOR j: REMark 2nd cube ok
1670 INK 3: drawCB3d ctcb-8
1680 :
1690 FOR j=1 TO 5
1700 ctth=ctth+1: IF rs2>ay THEN
1710  Rox=Cw(ctth,x)+ax: Roy=Cw(ctth,y)+ay: Roz=Cw(ctth,z)+az/8
1720 ok=VIEW_(Rox,Roy,Roz): Cw(ctth,1)=m: Cw(ctth,2)=n
1730 END IF : END FOR j: REMark 1st tetra ok
1740 INK 4: drawTh3d ctth-5
1750 :
1760 FOR j=1 TO 5
1770 ctth=ctth+1: IF rs2>ay THEN
1780  Rox=Cw(ctth,x)+ax: Roy=Cw(ctth,y)+ay: Roz=Cw(ctth,z)+az*1.1
1790 ok=VIEW_(Rox,Roy,Roz): Cw(ctth,1)=m: Cw(ctth,2)=n
1800 END IF : END FOR j: REMark 2nd tetra ok
1810 INK 6: drawTh3d ctth-5
1820 :
1830 FOR j=1 TO 9
1840 ctbs=ctbs+1: IF 1 THEN
1850  Rox=ba(ctbs,x): Roy=ba(ctbs,y): Roz=ba(ctbs,z)
1860 ok=VIEW_(Rox,Roy,Roz): ba(ctbs,1)=m: ba(ctbs,2)=n
1870 END IF : END FOR j: REMark ground base direction lines ok
1880 INK 2: drawBs3d ctbs-9
1890 :
1900 PAUSE 3: IF f<xt: CLS
1910 END FOR f
1920 :
1930  ct2=ct: ctcb2=ctcb: ctth2=ctth : ctbs2=ctbs: REMark perspective window x & y
1940  draw_animation: STOP
1950 ::::::::::::::::::::::::::::::
1960 :
1970 DEFine PROCedure draw_animation
1980 LOCal loop,kt,ktc,kth,ktb,f
1990 INK 7: CSIZE 3,1: AT 9,2: PRINT'...Go...': CSIZE 0,0
2000 AT 0,1: PRINT 'You patrol back & forth in a helicopter.'
2010 AT 1,1: PRINT "Fly the white 'pod' onto the blue iceberg" : OVER 1
2020 AT 3,1: PRINT 'Avoid the green explosive mine...'
2030 AT 5,1: PRINT "Use 'x' & 'c'   keys   for x coordinates"
2040 AT 7,1: PRINT 'Use left  & right    arrows for y coordinates'
2050 AT 9,1: PRINT 'Use up & down arrows for z coordinates'
2060 AT 13,1:PRINT 'Try to improve your timings...'
2070 AT 11,1:PRINT 'Try using NO instruments if you dare..': OVER 0: PAUSE -1
2080 :
2090 start=1: FOR f=20,30,40,50: BEEP 32767,f: PAUSE 50
2100 : CLS
2110 d1=DATE:  REPeat loop
2120  ct=ct2: ctcb=ctcb2: ctth=ctth2: ctbs=ctbs2
2130  kt=ct+0: ktc=ctcb+0: kth=ctth+0: ktb=ctbs+0
2140  :
2150  drn=1: REMark direction 'A' out ok
2160 FOR f=0 TO xt-1 STEP 1
2170  kt=kt-17: ktc=ktc-8-8: kth=kth-5-5: ktb=ktb-9
2180 INK 5: ct=kt+0    : drawGRid3d ct: REMark berg
2190 INK 2: ctcb=ktc+8 : drawCB3d ctcb: REMark cube
2200 INK 3: ctcb=ctcb+8: drawCB3d ctcb: REMark cube
2210 INK 4: ctth=kth+5 : drawTh3d ctth: REMark tetra
2220 INK 1: ctth=ctth+5: drawTh3d ctth: ctr=ctth-5: REMark mine
2230 INK 2: ctbs=ktb+9 : drawBs3d ctbs: REMark base
2240 crosswires ct: AT 0,1: PRINT 'A'!f!
2250 PAUSE 3: : REMark IF f=(xt-1): PAUSE 150
2260 CLS: END FOR f
2270 :
2280  drn=2: REMark direction 'B' back ok
2290 ct=0+17: ctcb=0+8+8: ctth=0+5+5: ctbs=0+9
2300 FOR f=0 TO xt-1 STEP 1
2310 INK 5: ct=ct+17    : drawGRid3d ct-17
2320 INK 2: ctcb=ctcb+8 : drawCB3d ctcb-8
2330 INK 3: ctcb=ctcb+8 : drawCB3d ctcb-8
2340 INK 4: ctth=ctth+5 : drawTh3d ctth-5
2350 INK 1: ctth=ctth+5 : drawTh3d ctth-5: ctr=ctth+0
2360 INK 2: ctbs=ctbs+9 : drawBs3d ctbs-9
2370 crosswires ct: AT 0,1: PRINT 'B'!f!
2380 PAUSE 3: REMark IF f=(xt-2): PAUSE 150
2390 CLS: END FOR f
2400 :
2410 END REPeat loop
2420 END DEFine
2430 :
2440 :::::::::::::::
2450 :
2460 DEFine FuNction VIEW_(vx,vy,vz)
2470 LOCal lx,ly,lz,lh,e,h
2480  REMark get perspective coordinates from absolute ones :
2490   REMark V(xyz)iew-point to T(xyz)rajectory point : H ypotenuse :
2500 lx=vx-tx+inf: ly=vy-ty: lz=vz-tzz : lh=((lx^2)+(ly^2))^.5+inf
2510   REMark h is azimut  :  e is dip-slope :
2520 e=ATN_(lz,lh)-b: h=ATN_(ly,lx)-c
2530   REMark keep angles within whole circle range :
2540 IF h > PI: h=h-PI*2: END IF
2550 IF h <-PI: h=h+PI*2: END IF
2560 IF e > PI: e=e-PI*2: END IF
2570 IF e <-PI: e=e+PI*2: END IF
2580   REMark m & n are screen coordinates :
2590 m=(TAN(h)*-asp): n=-1*TAN(e)*((m^2)+1)^.5
2600 RETurn 1
2610 END DEFine VIEW_
2620 :
2630 :::::::::::::::::::::
2640 :
2650 DEFine FuNction ATN_(oo,aa)
2660 LOCal so,sa,oa: REMark works around QDOS bugs.
2670  REMark adapt QL trigonometry to 3D trigonometry :
2680   REMark first get the line direction signs :
2690  so=(oo>0)-(oo<0): sa=(aa>0)-(aa<0)
2700 IF (so=0 OR so=+1) AND sa=0: RETurn 0
2710 IF so=0  AND sa=+1 : RETurn r90
2720 IF so=-1 AND sa=0  : RETurn r180
2730 IF so=0  AND sa=-1 : RETurn -r90
2740 oa=ATAN(aa/oo)
2750 IF so=+1 AND sa=+1 : RETurn oa
2760 IF so=-1 AND sa=+1 : RETurn oa-r360
2770 IF so=-1 AND sa=-1 : RETurn oa-r360
2780 IF so=+1 AND sa=-1 : RETurn oa
2790 END DEFine ATN_
2800 :
2810 :::::::::::::::::::
2820 :
2830 DATA -1, 1, 1,-1,-1, 1, 1,-1, 0: REMark cube x
2840 DATA -1,-1,-1,-1, 1, 1, 1, 1, 0: REMark cube y
2850 DATA -1,-1, 1, 1,-1,-1, 1, 1, 0: REMark cube z
2860 DATA  0, 2,-2, 0,2 : REMark tetra x
2870 DATA  0,+4,+4,+2,2 : REMark tetra y
2880 DATA  0, 0, 0, 4,2 : REMark tetra z
2890 DATA -6,-2, 2, 6, 6, 2,-2,-6,6,2,-2,-6,6,2,-2,-6,0 : REMark ground x
2900 DATA -6,-6,-6,-6,-2,-2,-2,-2,2,2, 2 ,2,6,6, 6, 6,0 : REMark ground y
2910 DATA 0,0,0,0,0,9,9,0,0,9,14,0,0,0,0,0,11           : REMark ground z
2920 DATA -1,+1,+3,+3,+1,-1,-3,-3 : REMark base x
2930 DATA -3,-3,-1,+1,+3,+3,+1,-1 : REMark base y
2940 DATA  0, 0, 0, 0, 0, 0, 0, 0 : REMark base z
2950 :
2960 ::::::::::::::::
2970 :
2980 DEFine PROCedure drawGRid3d(q)
2990          LINE t(q+1,x) ,t(q+1,y)  TO t(q+4,x) ,t(q+4,y)
3000          LINE t(q+2,x) ,t(q+2,y)  TO t(q+7,x),t(q+7,y) TO t(q+8,x),t(q+8,y)
3010          LINE t(q+12,x),t(q+12,y) TO t(q+11,x),t(q+11,y) TO t(q+15,x),t(q+15,y)
3020          LINE t(q+13,x),t(q+13,y) TO t(q+16,x),t(q+16,y)
3030          LINE t(q+9,x),t(q+9,y) TO t(q+10,x) ,t(q+10,y) TO t(q+14,x),t(q+14,y)
3040          LINE t(q+3,x) ,t(q+3,y)  TO t(q+6,x),t(q+6,y) TO t(q+5,x),t(q+5,y)
3050          LINE t(q+1,x) ,t(q+1,y)  TO t(q+16,x),t(q+16,y)
3060          LINE t(q+4,x) ,t(q+4,y)  TO t(q+13,x),t(q+13,y)
3070          LINE t(q+7,x) ,t(q+7,y)  TO t(q+6,x),t(q+6,y) TO t(q+10,x),t(q+10,y)
3080          LINE TO t(q+11,x) ,t(q+11,y) TO t(q+7,x),t(q+7,y)
3090          CIRCLE t(q+17,x), t(q+17,y),1E-2 : REMark 'iceberg' landing position
3100 END DEFine
3110 :
3120 ::::::::::::::::
3130 :
3140 DEFine PROCedure drawCB3d(q)
3150          LINE aw(q+1,x),aw(q+1,y) TO aw(q+5,x),aw(q+5,y)
3160          LINE aw(q+2,x),aw(q+2,y) TO aw(q+6,x),aw(q+6,y)
3170          LINE aw(q+3,x),aw(q+3,y) TO aw(q+7,x),aw(q+7,y)
3180          LINE aw(q+4,x),aw(q+4,y) TO aw(q+8,x),aw(q+8,y)
3190          LINE aw(q+1,x),aw(q+1,y) TO aw(q+4,x),aw(q+4,y)
3200          LINE aw(q+2,x),aw(q+2,y) TO aw(q+3,x),aw(q+3,y)
3210          LINE aw(q+6,x),aw(q+6,y) TO aw(q+7,x),aw(q+7,y)
3220          LINE aw(q+5,x),aw(q+5,y) TO aw(q+8,x),aw(q+8,y)
3230          LINE aw(q+1,x),aw(q+1,y) TO aw(q+2,x),aw(q+2,y)
3240          LINE aw(q+3,x),aw(q+3,y) TO aw(q+4,x),aw(q+4,y)
3250          LINE aw(q+5,x),aw(q+5,y) TO aw(q+6,x),aw(q+6,y)
3260          LINE aw(q+7,x),aw(q+7,y) TO aw(q+8,x),aw(q+8,y): REMark cube 3D
3270 END DEFine
3280 :
3290 ::::::::::::::::
3300 :
3310 DEFine PROCedure drawTh3d(q)
3320          LINE Cw(q+1,x),Cw(q+1,y) TO Cw(q+2,x),Cw(q+2,y)
3330          LINE Cw(q+2,x),Cw(q+2,y) TO Cw(q+3,x),Cw(q+3,y)
3340          LINE Cw(q+3,x),Cw(q+3,y) TO Cw(q+1,x),Cw(q+1,y)
3350          LINE Cw(q+4,x),Cw(q+4,y) TO Cw(q+1,x),Cw(q+1,y)
3360          LINE Cw(q+2,x),Cw(q+2,y) TO Cw(q+4,x),Cw(q+4,y)
3370          LINE Cw(q+3,x),Cw(q+3,y) TO Cw(q+4,x),Cw(q+4,y): REMark Tetra 3d
3380 END DEFine
3390 :
3400 ::::::::::::::::
3410 :
3420 DEFine PROCedure drawBs3d(q)
3430 INK 2,6,3:   LINE ba(q+1,x),ba(q+1,y) TO ba(q+6,x),ba(q+6,y)
3440              LINE ba(q+2,x),ba(q+2,y) TO ba(q+5,x),ba(q+5,y)
3450              CURSOR ba(q+5,x),ba(q+5,y),0,0: PRINT 'x'
3460 INK 2,7,3:   LINE ba(q+3,x),ba(q+3,y) TO ba(q+8,x),ba(q+8,y)
3470              LINE ba(q+4,x),ba(q+4,y) TO ba(q+7,x),ba(q+7,y): REMark ground 3d
3480              CURSOR ba(q+4,x),ba(q+4,y),0,0: PRINT 'y'
3490 END DEFine
3500 :
3510 ::::::::::::::::
3520 :
3530 DEFine PROCedure rotate2(axe,agl,xx,yy,zz)
3540 LOCal ang,ng,op,aj,hp,Sop,Saj: REMark positive tumble ok
3550 Rx=xx: Ry=yy: Rz=zz: IF Rx=0 : IF Ry=0: IF Rz=0: RETurn
3560   REMark OPposite & AJacent sides :
3570 op=Rz: aj=Rx: IF axe='1': aj=Ry: END IF : IF axe='3': op=Ry
3580   REMark get the signs of the line angles :
3590 IF  (1+aj)==1: aj=0: REMark Workaround to avoid QDOS ASIN bug.
3600 IF  (1+op)==1: op=0
3610 hp=((op*op)+(aj*aj))^.5
3620 Sop=(op>0)-(op<0): Saj=(aj>0)-(aj<0)
3630   :
3640   REMark get the trigonometric angles from the sides :
3650 IF Sop=0 AND Saj=0: GO TO 3890
3660 IF Sop=0 AND Saj>0: ang=0
3670 IF Sop>0 AND Saj>0: ang=ASIN(ABS(op/hp))
3680 IF Sop>0 AND Saj=0: ang=r90
3690 IF Sop>0 AND Saj<0: ang=r180-ASIN(ABS(op/hp))
3700 IF Sop=0 AND Saj<0: ang=r180
3710 IF Sop<0 AND Saj<0: ang=r180+ASIN(ABS(op/hp))
3720 IF Sop<0 AND Saj=0: ang=r270
3730 IF Sop<0 AND Saj>0: ang=r360-ASIN(ABS(op/hp))
3740   :
3750   REMark rotate the lines by adding agl on axis :
3760 ang=ang+agl: IF ang<0    : ang=ang+r360:  GO TO 3760: END IF
3770 IF ang>=r360:ang=ang-r360: GO TO 3770: END IF
3780 :
3790 IF ang=0                : Sop=0: Saj=1: op=0: aj=hp
3800 IF ang>0:    IF ang<r90 : Sop=1: Saj=1: op=hp*SIN(ang): aj=hp*COS(ang)
3810 IF ang=r90              : Sop=1: Saj=0: op=hp: aj=0
3820 IF ang>r90 : IF ang<r180: Sop=1: Saj=-1:ng=r180-ang:op=hp*SIN(ng):aj=hp*COS(ng)
3830 IF ang=r180             : Sop=0: Saj=-1: op=0: aj=hp
3840 IF ang>r180: IF ang<r270: Sop=-1:Saj=-1:ng=ang-r180:op=hp*SIN(ng):aj=hp*COS(ng)
3850 IF ang=r270             : Sop=-1: Saj=0: op=hp: aj=0
3860 IF ang>r270             : Sop=-1: Saj=1:ng=r360-ang:op=hp*SIN(ng):aj=hp*COS(ng)
3870   :
3880   REMark get transformed absolute coordinates :
3890 IF axe='1': Ry=aj*Saj: Rz=op*Sop: Rx=xx
3900 IF axe= 2 : Rx=aj*Saj: Rz=op*Sop: Ry=yy
3910 IF axe= 3 : Rx=aj*Saj: Ry=op*Sop: Rz=zz
3920 END DEFine rotate
3930 :
3940 :::::::::::::::::::::::::::::::
3950 DEFine PROCedure rotate1(axe,agl,xx,yy,zz)
3960 LOCal ang,ng,op,aj,hp,Sop,Saj: REMark negative tumble ok
3970 Rx=xx: Ry=yy: Rz=zz: IF Rx=0 : IF Ry=0: IF Rz=0: RETurn
3980   REMark OPposite & AJacent sides :
3990 op=Rz: aj=Rx: IF axe='1': aj=Ry: END IF : IF axe='3': op=Ry
4000   REMark get the signs of the line angles :
4010 IF  (1+aj)==1: aj=0
4020 IF  (1+op)==1: op=0
4030 hp=((op*op)+(aj*aj))^.5
4040 Sop=(op>0)-(op<0): Saj=(aj>0)-(aj<0)
4050   :
4060   REMark get the trigonometric angles from the sides :
4070 IF Sop=0 AND Saj=0: GO TO 4310
4080 IF Sop=0 AND Saj>0: ang=0
4090 IF Sop>0 AND Saj>0: ang=ASIN(ABS(op/hp))
4100 IF Sop>0 AND Saj=0: ang=r90
4110 IF Sop>0 AND Saj<0: ang=r180-ASIN(ABS(op/hp))
4120 IF Sop=0 AND Saj<0: ang=r180
4130 IF Sop<0 AND Saj<0: ang=r180+ASIN(ABS(op/hp))
4140 IF Sop<0 AND Saj=0: ang=r270
4150 IF Sop<0 AND Saj>0: ang=r360-ASIN(ABS(op/hp))
4160   :
4170   REMark rotate the lines by adding agl on axis :
4180 ang=ang-agl: IF ang>=r360    : ang=ang-r360:  GO TO 4180: END IF
4190 IF ang<0: ang=ang+r360: GO TO 4190: END IF
4200 :
4210 IF ang=0                : Sop=0: Saj=1: op=0: aj=hp
4220 IF ang>0:    IF ang<r90 : Sop=1: Saj=1: op=hp*SIN(ang): aj=hp*COS(ang)
4230 IF ang=r90              : Sop=1: Saj=0: op=hp: aj=0
4240 IF ang>r90 : IF ang<r180: Sop=1: Saj=-1:ng=r180-ang:op=hp*SIN(ng):aj=hp*COS(ng)
4250 IF ang=r180             : Sop=0: Saj=-1: op=0: aj=hp
4260 IF ang>r180: IF ang<r270: Sop=-1:Saj=-1:ng=ang-r180:op=hp*SIN(ng):aj=hp*COS(ng)
4270 IF ang=r270             : Sop=-1: Saj=0: op=hp: aj=0
4280 IF ang>r270             : Sop=-1: Saj=1:ng=r360-ang:op=hp*SIN(ng):aj=hp*COS(ng)
4290   :
4300   REMark get transformed absolute coordinates :
4310 IF axe='1': Ry=aj*Saj: Rz=op*Sop: Rx=xx
4320 IF axe= 2 : Rx=aj*Saj: Rz=op*Sop: Ry=yy
4330 IF axe= 3 : Rx=aj*Saj: Ry=op*Sop: Rz=zz
4340 END DEFine rotate
4350 :
4360 ::::::::::::::::::::
4370 DEFine PROCedure crosswires(qi)
4380 IF start=0: RETurn
4390  p=1 : REMark screen readouts ok
4400  im=t(qi+17,x): in=t(qi+17,y): iz=iz: i=xt-f: REMark berg pixels !
4410  mi=gd(qi,x): ni=gd(qi,y): zi=gd(qi,z): iz=zi      : REMark berg x,y,z
4420    IF drn=1: b=V(i,1): c=V(i,2): tx=V(i,3): ty=V(i,4): ax=V(i,6): tz=tzz
4430    IF drn=2: b=V(f,1): c=V(f,2): tx=V(f,3): ty=V(f,4): ax=V(f,6): tz=tzz
4440 :
4450  FOR loop3=0 TO 1*start
4460 :
4470      ky1=KEYROW(1): REMark 4_up 128_down 2_left 16_right
4480        SELect ky1
4490 =2:py=py+p:=16:py=py-p:=4:pz=pz+.1:=128:pz=pz-.1:=8:STOP:=REMAINDER :py=py:pz=pz
4500      END SELect
4510 :
4520     ky2=KEYROW(0): REMark 2_F1_x 8_F2_c
4530     SELect ky2: =2: px=px-p: =8:px=px+p: =REMAINDER : px=px
4532 :     IF KEYROW(7)=8: px=px+p
4534 :     IF KEYROW(2)=8: px=px-p
4540 :
4550     diam=1.15E-2: diam=diam/3: dia=2
4560     ok=VIEW_(0+px,0+py,1): omm=m: onn=n: REMark 'pod' positions
4570     ok=VIEW_(0+px,0+py,pz): INK 7: CIRCLE m,n,onn: CIRCLE m,n,diam
4580 :
4590 IF easy='1' THEN
4600     hitx=0: SELect im: =m-diam TO m+diam: hitx=1
4610     SELect m: =im-diam TO im+diam: hitx=1
4620     hity=0: SELect in: =n-diam TO n+diam: hity=1
4630     SELect n: =in-diam TO in+diam: hity=1
4640     hitz=0: SELect pz: =iz-.1 TO iz+.1: hitz=1
4650   ELSE
4660     hitx=0: SELect mi: =px-dia TO px+dia: hitx=1
4670             SELect px: =mi-dia TO mi+dia: hitx=1
4680     hity=0: SELect ni: =py-dia TO py+dia: hity=1
4690             SELect py: =ni-dia TO ni+dia: hity=1
4700     hitz=0: SELect pz: =zi-.2 TO zi+.2: hitz=1: REMark pod landed on iceberg
4710 END IF
4720 :      tm=Cw(ctr+5,x): tn=Cw(ctr+5,y): diam=1E-2: REMark green 'mine' pixels
4730        INK 4:  FILL 1: CIRCLE tm,tn,diam: FILL 0:
4740 :
4750     zapx=0: SELect tm: =m-diam TO m+diam: zapx=1
4760             SELect m: =tm-diam TO tm+diam: zapx=1
4770     zapy=0: SELect tn: =n-diam TO n+diam: zapy=1
4780             SELect n: =tn-diam TO tn+diam: zapy=1: REMark pod hit the mine
4790             zapz=0: SELect pz: =zi-1 TO zi+1: zapz=1
4800             zapz=1
4810 :
4820 REMark Show the readout coordinates :
4830 REMark INK 7:    AT 2,1: PRINT m,  : AT 2,10: PRINT n,  : AT 2,20: PRINT pz,
4840 REMark INK 5:    AT 3,1: PRINT im, : AT 3,10: PRINT in, : AT 3,20: PRINT iz,
4850        INK 2:    AT 1,1: PRINT 'x',: AT 1,10: PRINT 'y',: AT 1,20: PRINT 'z',
4860        INK 7:    AT 2,1: PRINT px, : AT 2,10: PRINT py, : AT 2,20: PRINT pz,
4870        INK 5:    AT 3,1: PRINT mi, : AT 3,10: PRINT ni, : AT 3,20: PRINT zi,
4880 :
4890     IF hitx=1: IF hity=1: IF hitz=1: done
4900     IF zapx=1: IF zapy=1: IF zapz=1: done
4910 PAUSE 1
4920 END FOR loop3: AT 0,21: PRINT !DATE-d1!'secs'!: REMark timer
4930 END DEFine
4940 :
4950 :::::::::::::
4960 :
4970 DEFine PROCedure done
4980 IF hitx=1: INK 5,0,3: ELSE INK 4,0,
4990 FOR k=1E-2 TO .15 STEP 1E-2: CIRCLE m,n,k: CSIZE 3,1
5000 IF hitx=1: BEEP 32767,0  : AT 9,6: PRINT! 'Won in'!DATE-d1!'secs'!!
5010 IF zapx=1: BEEP 32767,255: AT 9,6: PRINT!'Lost in'!DATE-d1!'secs'!!
5020 CSIZE 0,0: PAUSE 250: STOP
5030 END DEFine
5040 :
5050 :::::::::::::::::::::::::::::::::::::::
